//
//  ViewController.m
//  VideoOverlappingDemo
//
//  Created by Om's MINI on 11/27/12.
//  Copyright (c) 2012 Mobisoft's mini. All rights reserved.
//

#import "ViewController.h"
#import "MBProgressHUD.h"
#import "CustomVideoOverlapper.h"

@interface ViewController () {
    
    CustomVideoOverlapper *videoOverlapper;
    BOOL isVideoOne;
}

@end

@implementation ViewController

@synthesize videoOneButton = _videoOneButton;
@synthesize videoTwoButton = _videoTwoButton;
@synthesize overlapVideoButton = _overlapVideoButton;
@synthesize videoOneURL = _videoOneURL;
@synthesize videoTwoURL = _videoTwoURL;
@synthesize picker = _picker;


- (void)viewDidLoad {
    
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning {
    
    [super didReceiveMemoryWarning];
    
}

#pragma mark - Private Methods 

- (BOOL)browseMediaLibraryFromViewController:(UIViewController *)controller withDelegate:(id)delegate {
    
    //Validation
    
    if (([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeSavedPhotosAlbum] == NO)
        || (delegate == nil)
        || (controller == nil)) {
        
        return NO;
        
    }
    //Create image picker
    _picker = [[UIImagePickerController alloc] init];
    self.picker.sourceType = UIImagePickerControllerSourceTypeSavedPhotosAlbum;
    self.picker.mediaTypes = [[NSArray alloc] initWithObjects:(NSString *)kUTTypeMovie, nil];
    self.picker.allowsEditing = YES;
    self.picker.delegate = self;
    [self presentViewController:self.picker animated:YES completion:nil];
    
    return YES;
}

#pragma mark - Event Handlers

- (IBAction)videoOneButtonTapped:(id)sender {
    
    isVideoOne = YES;
    [self browseMediaLibraryFromViewController:self withDelegate:self];
    
}

- (IBAction)videoTwoButtonTapped:(id)sender {
    
    isVideoOne = NO;
    [self browseMediaLibraryFromViewController:self withDelegate:self];
    
}

- (IBAction)overlapVideoButtonTapped:(id)sender {
    
    videoOverlapper = [[CustomVideoOverlapper alloc] initWithController:self];
    
    //Pass Two video URL's we saved previously for merging process
    [videoOverlapper videoOverlappingMethodWithVideoOneURL:self.videoOneURL andVideoTwoURL:self.videoTwoURL];
       
}

#pragma mark - ImagePicker Delegate Methods

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info {    
    
    //dissmis ImagePickerController
    [self.picker dismissViewControllerAnimated:YES completion:nil];
    NSString *mediaType = [info objectForKey: UIImagePickerControllerMediaType];
    //handle Movie capture
    
    if ([mediaType isEqualToString:(NSString *)kUTTypeMovie ]) {
        
        NSLog(@"Matching Success");
        
        if (isVideoOne){
            NSLog(@"Video One  Loaded");
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Video One Loaded"
                                                            message:@"Video One Loaded"
                                                           delegate:nil
                                                  cancelButtonTitle:@"OK"
                                                  otherButtonTitles:nil];
            [alert show];
            
            //capture selected videoOneURL
            self.videoOneURL = [info objectForKey:UIImagePickerControllerMediaURL];
            NSLog(@"videoOneURL = %@",self.videoOneURL);
            
        } else {
            
            NSLog(@"Video two Loaded");
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Video Two Loaded"
                                                            message:@"Video Two Loaded"
                                                           delegate:nil
                                                  cancelButtonTitle:@"OK"
                                                  otherButtonTitles:nil];
            [alert show];
            
            //capture selected videoTwoURL
            self.videoTwoURL =[info objectForKey:UIImagePickerControllerMediaURL];
            NSLog(@"videoTwoURL = %@",self.videoTwoURL);
            
        }
        
    }

}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
    
    //dissmiss ImagePickerController
      [self.picker dismissViewControllerAnimated:YES completion:nil];
    
}

@end
