//
//  MoviePlayerHelper.m
//  VideoOverlappingDemo
//
//  Created by Om's MINI on 11/27/12.
//  Copyright (c) 2012 Mobisoft's mini. All rights reserved.
//

#import "CustomMoviePlayer.h"

@implementation CustomMoviePlayer

@synthesize controller = _controllerl;

@synthesize url = _url;

#pragma mark - Initialisation

- (id)initWithController:(UIViewController *)controller andURLForMovie:(NSURL *)url {
    
    self = [super init];
    
    if (self) {
        
        self.controller = controller;
        self.url = url;
    }
    return self;
    
}

#pragma mark - Public Method

- (void)playVideo {
    
    MPMoviePlayerViewController *theMovie = [[MPMoviePlayerViewController alloc]
                                             initWithContentURL:self.url];
    [self.controller presentMoviePlayerViewControllerAnimated:theMovie];
   
    // Register for the playback finished notification
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(myMovieFinishedCallback:)
                                                 name:MPMoviePlayerPlaybackDidFinishNotification
                                               object:theMovie];
}


#pragma mark - Notification 

- (void)myMovieFinishedCallback:(NSNotification *)notification {
        
    [self.controller dismissMoviePlayerViewControllerAnimated];
    MPMoviePlayerViewController *movie = [notification object];
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:MPMoviePlayerPlaybackDidFinishNotification object:movie];
}

@end
